<script>
import menuSection from '../components/menu_section.vue';
import subMenu from '../components/sub_menu.vue';
import contentTree from '../content_tree.json'; // eslint-disable-line import/no-unresolved

const componentNameToLabelMap = {
  dropdowns: 'dropdown',
  forms: 'form',
  labels: 'label',
  modals: 'modal',
  'radio-button': 'radio',
  tables: 'table',
  tabs: 'tab',
  toggles: 'toggle',
};

export default {
  gitlabOrgBaseUrl: 'https://gitlab.com/groups/gitlab-org/-/',
  components: {
    subMenu,
    menuSection,
  },
  data() {
    return {
      open: false,
      contentTree,
    };
  },
  computed: {
    contentWrapper() {
      return this.$route.fullPath === '/' ? '' : 'content main';
    },
    componentLabel() {
      const { section, slug } = this.$route.params;
      if (section !== 'components') {
        return null;
      }
      return componentNameToLabelMap[slug] || slug;
    },
  },
  mounted() {
    /**
     * bootstrap-vue renders components outside of the usual DOM, in the body
     * In order to apply our component-only styles, we are adding app-styles
     * to the wrapper element
     */
    this.$root.$on('bv::modal::show', (bvEvent, modalId) => {
      setTimeout(() => {
        document.getElementById(modalId).parentElement.classList.add('app-styles');
      }, 0);
    });
  },
};
</script>

<template>
  <div class="page">
    <div v-if="open" class="nav-sidebar__overlay" @click="open = false"></div>
    <button type="button" class="nav-sidebar__toggle" :aria-expanded="open" @click="open = !open">
      <svg
        width="32"
        height="32"
        viewBox="0 0 16 16"
        xmlns="http://www.w3.org/2000/svg"
        xmlns:xlink="http://www.w3.org/1999/xlink"
      >
        <title>Toggle menu</title>
        <path
          d="M2 3h12a1 1 0 0 1 0 2H2a1 1 0 1 1 0-2zm0 4h12a1 1 0 0 1 0 2H2a1 1 0 1 1 0-2zm0 4h12a1 1 0 0 1 0 2H2a1 1 0 0 1 0-2z"
        />
      </svg>
    </button>
    <nav :class="{ 'nav-sidebar--open': open }" class="nav-sidebar">
      <div class="nav-sidebar__header">
        <nuxt-link to="/" class="nav-sidebar__header-anchor p-a-5">
          <svg
            height="36"
            viewBox="0 0 376 342"
            xmlns="http://www.w3.org/2000/svg"
            class="tanuki-logo"
          >
            <g fill="none" fill-rule="evenodd">
              <path
                d="M185.398 341.13l68.013-209.322H117.39L185.4 341.13z"
                fill="#E24329"
                class="tanuki-shape tanuki-left-ear"
              />
              <path
                d="M185.398 341.13l-68.013-209.322h-95.32L185.4 341.128z"
                fill="#FC6D26"
                class="tanuki-shape tanuki-left-eye"
              />
              <path
                d="M22.066 131.808l-20.67 63.61c-1.884 5.803.18 12.16 5.117 15.744L185.398 341.13 22.066 131.807z"
                fill="#FCA326"
                class="tanuki-shape tanuki-left-cheek"
              />
              <path
                d="M22.066 131.808h95.32L76.42 5.735c-2.107-6.487-11.284-6.487-13.39 0L22.065 131.808z"
                fill="#E24329"
                class="tanuki-shape tanuki-nose"
              />
              <path
                d="M185.398 341.13l68.013-209.322h95.32L185.4 341.128z"
                fill="#FC6D26"
                class="tanuki-shape tanuki-right-eye"
              />
              <path
                d="M348.73 131.808l20.67 63.61c1.884 5.803-.18 12.16-5.117 15.744L185.398 341.13 348.73 131.807z"
                fill="#FCA326"
                class="tanuki-shape tanuki-right-cheek"
              />
              <path
                d="M348.73 131.808h-95.32L294.376 5.735c2.108-6.487 11.285-6.487 13.392 0l40.963 126.073z"
                fill="#E24329"
                class="tanuki-shape tanuki-right-ear"
              />
            </g>
          </svg>
          <span class="m-l-4">GitLab Design System</span>
        </nuxt-link>
      </div>
      <div class="nav-sidebar__body m-b-3">
        <template v-if="contentTree">
          <menu-section :content-tree="contentTree" category="brand" />
          <ul :open="$route.fullPath.startsWith('/product/')" class="nav-sidebar__section">
            <li>
              <span class="nav-sidebar__section-title">Product</span>
            </li>
            <sub-menu
              :content-tree="contentTree"
              category="get-started"
              category-name="Get started"
            />
            <sub-menu
              :content-tree="contentTree"
              category="product-foundations"
              category-name="Foundations"
            />
            <sub-menu :content-tree="contentTree" category="layout" />
            <sub-menu :content-tree="contentTree" category="components">
              <nuxt-link
                class="nav-sidebar__section-items-anchor nav-sidebar--indent-2"
                to="/components/status"
                >Status</nuxt-link
              >
            </sub-menu>
            <sub-menu
              :content-tree="contentTree"
              category="data-visualization"
              category-name="Data visualization"
            />
            <sub-menu :content-tree="contentTree" category="regions" />
            <sub-menu :content-tree="contentTree" category="objects" />
            <sub-menu :content-tree="contentTree" category="content" />
            <sub-menu :content-tree="contentTree" category="usability" />
            <nuxt-link
              class="nav-sidebar__section-items-anchor nav-sidebar--indent-1"
              to="/resources/design-resources"
              >Design resources</nuxt-link
            >
          </ul>
          <menu-section :content-tree="contentTree" category="research">
            <li>
              <a
                href="https://about.gitlab.com/community/gitlab-first-look/"
                target="_blank"
                rel="noopener"
                class="nav-sidebar__section-items-anchor nav-sidebar--indent-1"
                >First Look</a
              >
            </li>
            <li>
              <a
                href="https://about.gitlab.com/handbook/marketing/product-marketing/roles-personas/"
                target="_blank"
                rel="noopener"
                class="nav-sidebar__section-items-anchor nav-sidebar--indent-1"
                >Personas</a
              >
            </li>
          </menu-section>
          <menu-section :content-tree="contentTree" category="accessibility">
            <sub-menu
              :content-tree="contentTree"
              category="accessibility-audits"
              category-name="Audit guides"
            />
          </menu-section>
          <menu-section :content-tree="contentTree" category="contribute" />
        </template>
        <template v-else> Loading ... </template>
      </div>
    </nav>
    <div :class="contentWrapper">
      <nuxt />
      <footer class="content footer limited m-b-7 row justify-content-center">
        <edit-this-page-link>Edit this page</edit-this-page-link>
        <span class="footer-link-divider"></span>
        <edit-this-page-link
          edit-url="https://gitlab.com/-/ide/project/gitlab-org/gitlab-services/design.gitlab.com/edit/master/-"
        >
          Open Web IDE
        </edit-this-page-link>
        <span class="footer-link-divider"></span>
        <template v-if="componentLabel">
          <a
            :href="`${$options.gitlabOrgBaseUrl}issues?label_name%5B%5D=component%3A${componentLabel}`"
          >
            Related issues
          </a>
          <span class="footer-link-divider"></span>
          <a
            :href="`${$options.gitlabOrgBaseUrl}merge_requests?label_name%5B%5D=component%3A${componentLabel}`"
          >
            Related merge requests
          </a>
          <span class="footer-link-divider"></span>
        </template>
        <nuxt-link to="/contribute/get-started">Please contribute</nuxt-link>
      </footer>
    </div>
  </div>
</template>

<style lang="scss">
*,
*:before,
*:after {
  box-sizing: border-box;
}

body {
  margin: 0;
  padding: 0;
}
</style>
